#ifndef __genlib_H__
#define __genlib_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <assert.h>

#include "types.h"
#include "debug.h"
#include "mathlibx.h"


#ifdef WIN32

extern "C" 
{
  void win32_exit();
};


#define exit(STATUS)                        \
   if (STATUS == 0)                         \
     {                                      \
        win32_exit();                       \
     }                                      \
   exit(STATUS);                            \


#endif // WIN32

//////////////////////////////////////////////////////////////////////////////
// C++ Basic type List Functions
//

inline VOID DisplayValue(int i) { printf("%d", i); }
inline VOID SetNull(int &i) { i = 0; }
inline VOID SetMaxValue(int &i) { i = 0x7fffffff; }
inline VOID SetMinValue(int &i) { i = 0x80000000; }

inline VOID DisplayValue(INT_32 i) { printf("%ld", i); }
inline VOID SetNull(INT_32 &i) { i = 0; }
inline VOID SetMaxValue(INT_32 &i) { i = 0x7fffffff; }
inline VOID SetMinValue(INT_32 &i) { i = 0x80000000; }

inline VOID DisplayValue(UINT_32 i) { printf("%ld", i); }
inline VOID SetNull(UINT_32 &i) { i = 0; }
inline VOID SetMaxValue(UINT_32 &i) { i = 0xffffffff; }
inline VOID SetMinValue(UINT_32 &i) { i = 0; }

inline VOID DisplayValue(FLOAT f) { printf("%f", f); }
inline VOID SetNull(FLOAT &f) { f = 0.0; }
inline VOID SetMaxValue(FLOAT &f) { f = INFINITY; }
inline VOID SetMinValue(FLOAT &f) { f = -INFINITY; }

#endif // __genlib_H__


