#ifndef __OICOSAHEDRON_H__
#define __OICOSAHEDRON_H__

#include "symmetrygroup.h"

//////////////////////////////////////////////////////////////////////////////
// OIcosahedron
//

class OIcosahedron : public SymmetryGroup
{

//////////////////////////////////////////////////
// Initialization
//
public:
  OIcosahedron();
  virtual ~OIcosahedron();

  virtual VOID InitFaceGrid();
  virtual VOID InitSphereFaceGrid();
  virtual VOID InitOutline();

  virtual VOID InitFaceMatrices();
  virtual VOID InitTileMatrices();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output
//
public:
  virtual VOID OutputES(FILE *fpOutputFile, 
			CHAR *paletteFilename,
			CHAR *colorFilename);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual inline UINT_32 GetType() = 0;
  virtual VOID FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:

};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __OICOSAHEDRON_H__
