#ifndef __STETRAHEDRON_H__
#define __STETRAHEDRON_H__

#include "symmetrygroup.h"

//////////////////////////////////////////////////////////////////////////////
// STetrahedron
//

class STetrahedron : public SymmetryGroup
{

//////////////////////////////////////////////////
// Initialization
//
public:
  STetrahedron();
  virtual ~STetrahedron();

  virtual VOID InitFaceGrid();
  virtual VOID InitTileGrid();

  virtual VOID InitSphereFaceGrid();
  virtual VOID InitSphereTileGrid();
  virtual VOID InitOutline();

  virtual VOID InitFaceMatrices();
  virtual VOID InitTileMatrices();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output
//
public:
  virtual VOID OutputES(FILE *fpOutputFile, 
			CHAR *paletteFilename,
			CHAR *colorFilename);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual VOID InsertOutlinePoint(UINT_32 uiSelectedPoint, Point ptLocation);
  virtual VOID FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:

};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __STETRAHEDRON_H__
