proc setup {} {
    wm title    . "Escher Ball"
    wm geometry . +200+200


    frame .main


    #######################
    ### Menu Bar
    frame .main.menubar -relief raised -bd 2

    menubutton .main.menubar.file  -text File -underline 0 \
	    -menu .main.menubar.file.menu
    menubutton .main.menubar.group -text "SymmetryGroup" -underline 0 \
	    -menu .main.menubar.group.menu

    pack .main.menubar.file .main.menubar.group -side left

    set m1 [menu .main.menubar.file.menu -tearoff 0]
    $m1 add cascade -label "Save As" -menu $m1.saveas
    $m1 add command -label "Quit"    -command exit -accelerator "<Esc>"

    set m1_1 [menu $m1.saveas -tearoff 0]
    $m1_1 add command -label "SLF" -command "puts saveSLF"
    $m1_1 add command -label "STL" -command "puts saveSTL"

    set m2 [menu .main.menubar.group.menu -tearoff 0]
    $m2 add radiobutton -label "Oriented Tetrahedron"           -variable sym -value 1 
    $m2 add radiobutton -label "Straight Tetrahedron"           -variable sym -value 2 
    $m2 add radiobutton -label "Oriented Octahedron(Cube)"       -variable sym -value 3 
    $m2 add radiobutton -label "Straight Octahedron(Cube)"       -variable sym -value 4 
    $m2 add radiobutton -label "Oriented Icosa-(dodeca)-hedron" -variable sym -value 5 
    $m2 add radiobutton -label "Straight Icosa-(dodeca)-hedron" -variable sym -value 6 


    global sym
    set sym 1

    #######################
    ### Status Bar
    frame .main.statusbar -relief raised -bd 2

    label .main.statusbar.label -text " " -pady 4
    label .main.statusbar.logo1 -text "Escher Ball" -relief groove
    label .main.statusbar.logo2 -text "Spring 2000" -relief groove

    pack .main.statusbar.label -side left -ipadx 6
    pack .main.statusbar.logo2 -side right -padx 4
    pack .main.statusbar.logo1 -side right

    #######################
    ### Edit Panel

    frame .main.edit -relief raised -bd 2


    frame .main.edit.draw

    ### draw
    radiobutton .main.edit.draw.ball   -variable draw -value 0 \
	    -text "sphere" -command "setDraw 0" 
    radiobutton .main.edit.draw.poly   -variable draw -value 1 \
	    -text "polyhedra" -command "setDraw 1"
    radiobutton .main.edit.draw.stereo -variable draw -value 2 \
	    -text "stereographic tile points" -command "setDraw 2"
    radiobutton .main.edit.draw.tile   -variable draw -value 3 \
	    -text "triangulated tile" -command "setDraw 3"
    radiobutton .main.edit.draw.solid   -variable draw -value 4 \
	    -text "solid tile" -command "setDraw 4"

    grid .main.edit.draw.ball  -row 0 -col 0
    grid .main.edit.draw.poly  -row 1 -col 0
    grid .main.edit.draw.stereo -row 2 -col 0
    grid .main.edit.draw.tile  -row 3 -col 0
    grid .main.edit.draw.solid -row 4 -col 0

    global draw
    set draw 0

    ####
    label  .main.edit.foo  -text ""
    button .main.edit.new  -text "Start Inner Pts" -command {

        set r [.main.edit.new cget -relief]

	if { $r == "sunken" } {
	    .main.edit.new config -relief raised
	    .main.edit.new config -text "Start Inner Pts"
	} else {
	    .main.edit.new config -relief sunken
	    .main.edit.new config -text "End Inner Pts"
	}

	innerPoints
    }

    ###
    radiobutton .main.edit.no -text "No grid"   -variable drawGrid -value 0\
	    -command {drawGrid 0}
    radiobutton .main.edit.face -text "Face grid" -variable drawGrid -value 1 \
	    -command {drawGrid 1}
    radiobutton .main.edit.tile -text "Tile grid" -variable drawGrid -value 2 \
	    -command {drawGrid 2}

    global drawGrid
    set drawGrid 1


    ###
    frame .main.edit.solid
    label .main.edit.solid.label -text "Thickness %:"
    scale .main.edit.solid.th -from 0.01 -to 1 -variable thickness -orient horizontal \
	    -tickinterval 0.99 -resolution 0.01 -command "setThickness"

    global thickness
    set thickness 0.8

    grid .main.edit.solid.label -row 0 -col 0
    grid .main.edit.solid.th    -row 0 -col 1




    grid .main.edit.draw       -row 1 -col 0               -sticky w

    grid .main.edit.no         -row 2 -col 0 -columnspan 2 -sticky w -ipady 5
    grid .main.edit.face       -row 3 -col 0 -columnspan 2 -sticky w -ipady 5
    grid .main.edit.tile       -row 4 -col 0 -columnspan 2 -sticky w -ipady 5

    grid .main.edit.foo        -row 5 -col 0 -columnspan 2
    grid .main.edit.new        -row 6 -col 0 -columnspan 2 -sticky w,e,s

    grid .main.edit.solid      -row 7 -col 0 -columnspan 2 -sticky w,e


    ##########################
    ### layout

    grid .main.menubar    -row 0 -col 0 -columnspan 2       -sticky w,e
    grid .main.edit       -row 1 -col 1 -ipadx 10 -ipady 10 -sticky w,e,n,s
    grid .main.statusbar  -row 2 -col 0 -columnspan 2 -sticky w,e

    ### main
    grid .main -row 0 -col 0
}

proc main { } {

    initialize
    setup
    
    update idletasks
    guiCreated
}

setup




