proc SetStatusLabel { text } {

    .main.statusbar.label config -text $text
}

proc resetInnerPoints { } {

    .main.edit.new config -relief raised
    .main.edit.new config -text "Start Inner Pts"
}

proc getWHXY { } {
    set whxy [wm geom .]

    set i 0
    while { [string index $whxy $i] != "x" } {
	incr i
    }
    set w [string range $whxy 0 [expr $i-1]]

    set j $i
    while { [string index $whxy $j] != "+" } {
	incr j
    }
    set h [string range $whxy [expr $i+1] [expr $j-1]]

    set i [expr $j+1]
    incr j
    while { [string index $whxy $j] != "+" } {
	incr j
    }
    incr j -1

    set x [string range $whxy $i $j]
    set y [string range $whxy [expr $j+2] [string length $whxy]]

    #puts "whxy: $whxy"
    #puts "w h x y: $w $h $x $y"

    return "$w $h $x $y"
}

proc dialogWindow { } {

    # Change the window to only a border
    wm transient .dialog .
    wm withdraw .dialog
    wm overrideredirect .dialog 0
    wm deiconify .dialog

    # Place this window
    set whxy [getWHXY]
    set w [lindex $whxy 0]
    set h [lindex $whxy 1]
    set x [lindex $whxy 2]
    set y [lindex $whxy 3]

    set xx [expr $x + 50]
    set yy [expr $y + 100]
    set xy "+$xx+$yy"    
    wm geom .dialog $xy

#    wm geom .dialog +300+300
}

proc dialogOTTile { } {
    global eOTetra

    toplevel .dialog
    button .dialog.t1 -image ottile1 -command "destroy .dialog; setSymmetryGroup $eOTetra 1"
    button .dialog.t2 -image ottile2 -command "destroy .dialog; setSymmetryGroup $eOTetra 2"
    label .dialog.label -text "Select a tetrahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 2 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOOTile { } {
    global eOOcta

    toplevel .dialog
    button .dialog.t1 -image ootile1 -command "destroy .dialog; setSymmetryGroup $eOOcta 1"
    button .dialog.t2 -image ootile2 -command "destroy .dialog; setSymmetryGroup $eOOcta 2"
    button .dialog.t3 -image ootile3 -command "destroy .dialog; setSymmetryGroup $eOOcta 3"
    label .dialog.label -text "Select a octahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOCTile { } {
    global eOCube

    toplevel .dialog
    button .dialog.t1 -image octile1 -command "destroy .dialog; setSymmetryGroup $eOCube 1"
    button .dialog.t2 -image octile2 -command "destroy .dialog; setSymmetryGroup $eOCube 2"
    button .dialog.t3 -image octile3 -command "destroy .dialog; setSymmetryGroup $eOCube 3"
    label .dialog.label -text "Select a cube tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOITile { } {
    global eOIcosa

    toplevel .dialog
    button .dialog.t1 -image oitile1 -command "destroy .dialog; setSymmetryGroup $eOIcosa 1"
    button .dialog.t2 -image oitile2 -command "destroy .dialog; setSymmetryGroup $eOIcosa 2"
    button .dialog.t3 -image oitile3 -command "destroy .dialog; setSymmetryGroup $eOIcosa 3"
    label .dialog.label -text "Select a icosahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogODTile { } {
    global eODodeca

    toplevel .dialog
    button .dialog.t1 -image odtile1 -command "destroy .dialog;setSymmetryGroup $eODodeca 1"
    button .dialog.t2 -image odtile2 -command "destroy .dialog;setSymmetryGroup $eODodeca 2"
    button .dialog.t3 -image odtile3 -command "destroy .dialog;setSymmetryGroup $eODodeca 3"
    label .dialog.label -text "Select a dodecahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc initialize { } {

    initImages
}

proc initImages { } {
    global ottile1 ottile2

    image create photo ottile1 
    ottile1 configure -file "images/ottile1_150.gif"
    
    image create photo ottile2 
    ottile2 configure -file "images/ottile2_150.gif"

    image create photo ootile1
    ootile1 configure -file "images/ootile1_150.gif"

    image create photo ootile2
    ootile2 configure -file "images/ootile2_150.gif"

    image create photo ootile3
    ootile3 configure -file "images/ootile3_150.gif"

    image create photo octile1
    octile1 configure -file "images/octile1_150.gif"

    image create photo octile2
    octile2 configure -file "images/octile2_150.gif"

    image create photo octile3
    octile3 configure -file "images/octile3_150.gif"

    image create photo oitile1
    oitile1 configure -file "images/oitile1_150.gif"

    image create photo oitile2
    oitile2 configure -file "images/oitile2_150.gif"

    image create photo oitile3
    oitile3 configure -file "images/oitile3_150.gif"

    image create photo odtile1
    odtile1 configure -file "images/odtile1_150.gif"

    image create photo odtile2
    odtile2 configure -file "images/odtile2_150.gif"

    image create photo odtile3
    odtile3 configure -file "images/odtile3_150.gif"
}

proc setup {} {
    global eOTetra eSTetra eOOcta eSOcta eOCube eSCube eOIcosa eSIcosa eODodeca eSDodeca
    global ePDodeca

    wm title    . "Escher Ball"
    wm geometry . +200+200


    frame .main

    #######################
    ### Togl Widget
    frame .main.sphere -relief raised -bd 2

    togl .main.sphere.togl -width 500 -height 500 -rgba true -double true \
	    -depth true -ident Ball 

    grid .main.sphere.togl -row 0 -col 0

    # binding key to .main.sphere.togl doesn't work, must use bind all
    #bind all <KeyPress>   ".main.sphere.togl keyboard %K 0 %x %y"
    bind all <KeyRelease> ".main.sphere.togl keyboard %K 1 %x %y"

    bind .main.sphere.togl <ButtonPress>   ".main.sphere.togl mouseButton %b 0 %x %y %t"
    bind .main.sphere.togl <ButtonRelease> ".main.sphere.togl mouseButton %b 1 %x %y %t"
    bind .main.sphere.togl <B1-Motion> ".main.sphere.togl mouseMotion 1 %x %y %t"
    bind .main.sphere.togl <B2-Motion> ".main.sphere.togl mouseMotion 2 %x %y %t"
    bind .main.sphere.togl <B3-Motion> ".main.sphere.togl mouseMotion 3 %x %y %t"
    
    bind all <Escape> "exit"

    #######################
    ### Menu Bar
    frame .main.menubar -relief raised -bd 2

    menubutton .main.menubar.file  -text File -underline 0 \
	    -menu .main.menubar.file.menu
    menubutton .main.menubar.group -text "SymmetryGroup" -underline 0 \
	    -menu .main.menubar.group.menu
    menubutton .main.menubar.grid -text "GridOptions" -underline 0 \
	    -menu .main.menubar.grid.menu

    pack .main.menubar.file .main.menubar.group .main.menubar.grid -side left

    set m1 [menu .main.menubar.file.menu -tearoff 0]
    $m1 add command -label "Save"    -command "outputEB"
    $m1 add cascade -label "Save As" -menu $m1.saveas
    $m1 add command -label "Quit"    -command exit -accelerator "<Esc>"

    set m1_1 [menu $m1.saveas -tearoff 0]
    $m1_1 add command -label "SLF" -command "puts saveSLF"
    $m1_1 add command -label "STL" -command "outputSTL"

    set m2 [menu .main.menubar.group.menu -tearoff 0]
    $m2 add radiobutton -label "Oriented Tetrahedron"  -variable sym -value 0 \
	    -command "dialogOTTile"
    $m2 add radiobutton -label "Straight Tetrahedron"  -variable sym -value 1 \
	    -command "setSymmetryGroup $eSTetra 0"
    $m2 add radiobutton -label "Oriented Octahedron"   -variable sym -value 2 \
	    -command "dialogOOTile"
#    $m2 add radiobutton -label "Straight Octahedron"  -variable sym -value 3 
    $m2 add radiobutton -label "Oriented Cube"         -variable sym -value 4 \
	    -command "dialogOCTile"
#    $m2 add radiobutton -label "Straight Cube"        -variable sym -value 5 
    $m2 add radiobutton -label "Oriented Icosahedron"  -variable sym -value 6 \
	    -command "dialogOITile"
#    $m2 add radiobutton -label "Straight Icosahedron" -variable sym -value 7 

    $m2 add radiobutton -label "Oriented Dodecahedron" -variable sym -value 8 \
	    -command "dialogODTile"
    $m2 add radiobutton -label "Penta Dodecahedron"    -variable sym -value 10 \
	    -command "setSymmetryGroup $ePDodeca 0"



    set m3 [menu .main.menubar.grid.menu -tearoff 0]
    $m3 add radiobutton -label "No grid" -variable drawGrid -value 0 \
	    -command {drawGrid 0}
    $m3 add radiobutton -label "Face grid" -variable drawGrid -value 1 \
	    -command {drawGrid 1}
    $m3 add radiobutton -label "Tile grid" -variable drawGrid -value 2 \
	    -command {drawGrid 2}

    global drawGrid
    set drawGrid 1

    global sym
    set sym $eOTetra
    setSymmetryGroup $eOTetra 1

    #######################
    ### Status Bar
    frame .main.statusbar -relief raised -bd 2

    label .main.statusbar.label -text " " -pady 4
    label .main.statusbar.logo1 -text "Escher Ball" -relief groove
    label .main.statusbar.logo2 -text "Spring 2000" -relief groove

    pack .main.statusbar.label -side left -ipadx 6
    pack .main.statusbar.logo2 -side right -padx 4
    pack .main.statusbar.logo1 -side right

    #######################
    ### Edit Panel

    frame .main.edit -relief raised -bd 2

    button .main.edit.reset  -text "camera reset" -command ".main.sphere.togl camera 1"

    frame .main.edit.draw

    ### draw
    radiobutton .main.edit.draw.ball   -variable draw -value 0 \
	    -text "sphere" -command "setDraw 0" 
    radiobutton .main.edit.draw.poly   -variable draw -value 1 \
	    -text "polyhedra" -command "setDraw 1"
    radiobutton .main.edit.draw.stereo -variable draw -value 2 \
	    -text "stereographic tile points" -command "setDraw 2"
    radiobutton .main.edit.draw.tile   -variable draw -value 3 \
	    -text "triangulated tile" -command "setDraw 3"
    radiobutton .main.edit.draw.solid   -variable draw -value 4 \
	    -text "solid tile" -command "setDraw 4"

    grid .main.edit.draw.poly   -row 0 -col 0 -sticky w
    grid .main.edit.draw.ball   -row 1 -col 0 -sticky w
    grid .main.edit.draw.stereo -row 2 -col 0 -sticky w
    grid .main.edit.draw.tile   -row 3 -col 0 -sticky w
    grid .main.edit.draw.solid  -row 4 -col 0 -sticky w

    global draw
    set draw 0

    ####
    button .main.edit.new  -text "Start Inner Pts" -command {

        set r [.main.edit.new cget -relief]

	if { $r == "sunken" } {
	    .main.edit.new config -relief raised
	    .main.edit.new config -text "Start Inner Pts"
	} else {
	    .main.edit.new config -relief sunken
	    .main.edit.new config -text "End Inner Pts"
	}

	innerPoints
    }

    ###
    frame .main.edit.solid
    label .main.edit.solid.label -text "Thickness %:"
    scale .main.edit.solid.th -from 0.01 -to 0.99 -variable thickness -orient horizontal \
	    -tickinterval 0.98 -resolution 0.001 -command "setThickness"

    global thickness
    set thickness 0.2

    grid .main.edit.solid.label -row 0 -col 0
    grid .main.edit.solid.th    -row 0 -col 1


    ### .main.edit 

    grid .main.edit.reset      -row 0 -col 0 -columnspan 2 -sticky n,w,e
    grid .main.edit.draw       -row 1 -col 0               -sticky w
    grid .main.edit.solid      -row 2 -col 0 -columnspan 2 -sticky w,e   -pady 10
    grid .main.edit.new        -row 3 -col 0 -columnspan 2 -sticky w,e,s



    ##########################
    ### layout

    grid .main.menubar    -row 0 -col 0 -columnspan 2       -sticky w,e
    grid .main.sphere     -row 1 -col 0 -ipadx 10 -ipady 10                             
    grid .main.edit       -row 1 -col 1 -ipadx 10 -ipady 10 -sticky w,e,n,s
    grid .main.statusbar  -row 2 -col 0 -columnspan 2 -sticky w,e

    ### main
    grid .main -row 0 -col 0
}

proc main { } {
    global eOTetra eSTetra eOOcta eSOcta eOCube eSCube eOIcosa eSIcosa eODodeca eSDodeca
    global ePDodeca

    set eOTetra  0
    set eSTetra  1
    set eOOcta   2
    set eSOcta   3
    set eOCube   4
    set eSCube   5
    set eOIcosa  6
    set eSIcosa  7
    set eODodeca 8
    set eSDodeca 9
    set ePDodeca 10


    initialize
    setup
    
    update idletasks
    guiCreated
}

#puts "auto_path = $auto_path"
main




