#ifndef __DTETRAHEDRON_H__
#define __DTETRAHEDRON_H__

#include "symmetrygroup.h"

//////////////////////////////////////////////////////////////////////////////
// DTetrahedron
//

class DTetrahedron : public SymmetryGroup
{

//////////////////////////////////////////////////
// Initialization
//
public:
  DTetrahedron();
  virtual ~DTetrahedron();

  virtual VOID InitFaceGrid();
  virtual VOID InitTileGrid();

  virtual VOID InitSphereFaceGrid();
  virtual VOID InitSphereTileGrid();
  virtual VOID InitOutline();

  virtual VOID InitFaceMatrices();
  virtual VOID InitTileMatrices();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output
//
public:
  virtual VOID OutputES(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual VOID InsertOutlinePoint(UINT_32 uiSelectedPoint, Point ptLocation);
  virtual VOID FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:

};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __DTETRAHEDRON_H__
