#include "odtile2.h"

//////////////////////////////////////////////////////////////////////
// ODTile2 Class
//

ODTile2::ODTile2()
{
  Vector v1, v2, v3, v4;
  FLOAT f;
  
  v1.Set( 0.0, (GOLDENRATIO + 2.0)/5.0, (INVGOLDENRATIO + 2*GOLDENRATIO + 2.0)/5.0 );
  v2.Set( 1.0, 1.0, 1.0);
  v3.Set( 0.5, (GOLDENRATIO + 1.0)/2.0, (INVGOLDENRATIO + 1.0)/2.0);
  v4.Set( 0.0, GOLDENRATIO, INVGOLDENRATIO);

  f = 1.0 / v4.Magnitude();

  v1 *= f;
  v2 *= f;
  v3 *= f;
  v4 *= f;

  // 2D
  m_pt2DTilePoint1.Set(v1[X], v1[Y], v1[Z]);
  m_pt2DTilePoint2.Set(v2[X], v2[Y], v2[Z]);
  m_pt2DTilePoint3.Set(v3[X], v3[Y], v3[Z]);
  m_pt2DTilePoint4.Set(v4[X], v4[Y], v4[Z]);

  Init();
}

ODTile2::~ODTile2()
{
}

///////////////////////////////////////////////////////////////////////////////

VOID ODTile2::FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1)
{
  Vector v;

  if( tpt1->GetType() != tpTILE )
    {
      m1 = tpt1->GetPartnerMatrix();
      m2 = (tpt1->GetPartner())->GetPartnerMatrix();
    }
  else if( tpt1->GetTilePoint() == 1 )
    {
      v.Set(0.0, (GOLDENRATIO + 2.0)/5.0, (INVGOLDENRATIO + 2*GOLDENRATIO + 2.0)/5.0 );
      m1.SetRotate(v, DEGTORAD(72));
      m2.SetRotate(v, DEGTORAD(-72));
    }
  else if( tpt1->GetTilePoint() == 2 )
    {
      v.Set(0.5, (GOLDENRATIO + 1.0)/2.0, (INVGOLDENRATIO + 1.0)/2.0);
      m1.SetRotate(v, DEGTORAD(-180));
      m2.SetRotate(v, DEGTORAD(180));
    }
  else if( tpt1->GetTilePoint() == 3 )
    {
      v.Set(0.5, (GOLDENRATIO + 1.0)/2.0, (INVGOLDENRATIO + 1.0)/2.0);
      m1.SetRotate(v, DEGTORAD(180));
      m2.SetRotate(v, DEGTORAD(-180));
    }
  else if( tpt1->GetTilePoint() == 4 )
    {
      v.Set(0.0, (GOLDENRATIO + 2.0)/5.0, (INVGOLDENRATIO + 2*GOLDENRATIO + 2.0)/5.0 );
      m1.SetRotate(v, DEGTORAD(-72));
      m2.SetRotate(v, DEGTORAD(72));
    }
  else
    {
      ASSERT(FALSE);
    }
}

///////////////////////////////////////////////////////////////////////////////

VOID ODTile2::OutputES(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "ododecahedron tile 2\n\n" );

  m_pTile->OutputES(fpOutputFile);

  OutputESColor(fpOutputFile);
}
