#include "oitile1.h"

//////////////////////////////////////////////////////////////////////
// OITile1 Class
//

OITile1::OITile1()
{
  Vector v1, v2, v3, v4;
  FLOAT f, theta, y, z;

  theta = atan( GOLDENRATIO / (GOLDENRATIO - 1.0) );
  y = sin(theta) / sqrt(3.0);
  z = GOLDENRATIO - (cos(theta) / sqrt(3.0));

  v1.Set( 0.0, y, z);
  v2.Set( 0.5, GOLDENRATIO/2.0, (1.0 + GOLDENRATIO)/2.0);
  v3.Set( 0.0, GOLDENRATIO, 1.0);
  v4.Set(-0.5, GOLDENRATIO/2.0, (1.0 + GOLDENRATIO)/2.0 );

  f = 1.0 / v3.Magnitude();

  v1 *= f;
  v2 *= f;
  v3 *= f;
  v4 *= f;

  // 2D
  m_pt2DTilePoint1.Set(v1[X], v1[Y], v1[Z]);
  m_pt2DTilePoint2.Set(v2[X], v2[Y], v2[Z]);
  m_pt2DTilePoint3.Set(v3[X], v3[Y], v3[Z]);
  m_pt2DTilePoint4.Set(v4[X], v4[Y], v4[Z]);

  Init();
}

OITile1::~OITile1()
{
}

///////////////////////////////////////////////////////////////////////////////

VOID OITile1::FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1)
{
  Vector v;

  if( tpt1->GetType() != tpTILE )
    {
      m1 = tpt1->GetPartnerMatrix();
      m2 = (tpt1->GetPartner())->GetPartnerMatrix();
    }
  else if( tpt1->GetTilePoint() == 1 )
    {
      FLOAT theta, y, z;
      theta = atan( GOLDENRATIO / (GOLDENRATIO - 1.0) );
      y = cos(theta) / sqrt(3.0);
      z = sin(theta) / sqrt(3.0);

      v.Set( 0.0, y, z );
      m1.SetRotate(v, DEGTORAD(120));
      m2.SetRotate(v, DEGTORAD(-120));
    }
  else if( tpt1->GetTilePoint() == 2 )
    {
      v.Set(0.0, GOLDENRATIO, 1.0);
      m1.SetRotate(v, DEGTORAD(-72));
      m2.SetRotate(v, DEGTORAD(72));
    }
  else if( tpt1->GetTilePoint() == 3 )
    {
      v.Set(0.0, GOLDENRATIO, 1.0);
      m1.SetRotate(v, DEGTORAD(72));
      m2.SetRotate(v, DEGTORAD(-72));
    }
  else if( tpt1->GetTilePoint() == 4 )
    {
      FLOAT theta, y, z;
      theta = atan( GOLDENRATIO / (GOLDENRATIO - 1.0) );
      y = cos(theta) / sqrt(3.0);
      z = sin(theta) / sqrt(3.0);

      v.Set( 0.0, y, z );
      m1.SetRotate(v, DEGTORAD(-120));
      m2.SetRotate(v, DEGTORAD(120));
    }
  else
    {
      ASSERT(FALSE);
    }
}

///////////////////////////////////////////////////////////////////////////////

VOID OITile1::OutputES(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "oicosahedron tile 1\n\n" );

  m_pTile->OutputES(fpOutputFile);

  OutputESColor(fpOutputFile);
}
