#ifndef __SNAPPOINT_H__
#define __SNAPPOINT_H__

#include "mathlib.h"
#include "datalib.h"

class TilePoint;

//////////////////////////////////////////////////////////////////////////////
// SnapPoint
//

class SnapPoint
{

//////////////////////////////////////////////////
// Initialization
//
public:
  SnapPoint();
  virtual ~SnapPoint();

//////////////////////////////////////////////////
// Functions
//
public:
  VOID SnapTilePoints(FLOAT fHeight, Point pt);
  
//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline VOID SetHeightPoint(Point pt);
  inline Point GetHeightPoint();
  
  inline VOID SetSnapped(BOOL b);

  inline TilePoint* RemoveTilePoint(TilePoint *tpt);
  inline VOID AddTilePoint(TilePoint *tpt);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:

  Point m_ptHeight;          // Snap Point along normal

  BOOL m_bSnapped;
  CListInt m_listTilePoints; // points that have same position
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID SnapPoint::SetHeightPoint(Point pt)
{
  m_ptHeight = pt;
}

inline Point SnapPoint::GetHeightPoint()
{
  return m_ptHeight;
}

inline VOID SnapPoint::SetSnapped(BOOL b)
{
  m_bSnapped = b;
}

inline TilePoint* SnapPoint::RemoveTilePoint(TilePoint *tpt)
{
  m_listTilePoints.RemoveUnordered((UINT_32)tpt);

  if( m_listTilePoints.GetLength() == 1 )
    {
      CListIterInt iter;
      
      iter.Init(&m_listTilePoints);
      return (TilePoint *)(iter.PeekFirst()); 
    }
  
  return NULL;
}

inline VOID SnapPoint::AddTilePoint(TilePoint *tpt)
{
  m_listTilePoints.InsertLast(tpt, (UINT_32)tpt);
}

#endif // __SNAPPOINT_H__
